

var Rk,Ws,Wp,Pm,P,R,Pz;%7
var C,I,B,A,q,G,T,er,Z,ST,CE,K,M,%13
Ks,Kp,Ls,Lp,%4
EtaM,EtaL,ysd,ys,yp;%5
%29
varexo e_q,e_A,e_G,e_z;


parameters
BETA,
SIGMA,V,MU,TAU_l,TAU_k,TAU_m,
DELTA,ALPHA_sk,ALPHA_sm,ALPHA_pk,ALPHA_py,
GAMMA_m,LAMBDA,DELTA_z,
ETA0,ETA1,ETA2,
THETA_s,THETA_p,b_s,b_p,
RHO_q,RHO_A,RHO_old,RHO_G,RHO_z,
A_ss,q_ss,G_ss;

parameters
Rk_ss,Ws_ss,Wp_ss,Pm_ss,P_ss,R_ss,Pz_ss,
C_ss,I_ss,B_ss,
T_ss,er_ss,Z_ss,ST_ss,CE_ss,K_ss,M_ss,
Ks_ss,Kp_ss,Ls_ss,Lp_ss,
EtaM_ss,EtaL_ss,ysd_ss,ys_ss,yp_ss;

//-----------------参数校准-------------------
load PARA.mat
set_param_value('BETA',BETA);
set_param_value('SIGMA',SIGMA);
set_param_value('V',V);
set_param_value('MU',MU);
set_param_value('TAU_l',TAU_l);
set_param_value('TAU_k',TAU_k);
set_param_value('TAU_m',TAU_m);
set_param_value('DELTA',DELTA);
set_param_value('ALPHA_sk',ALPHA_sk);
set_param_value('ALPHA_sm',ALPHA_sm);
set_param_value('ALPHA_pk',ALPHA_pk);
set_param_value('ALPHA_py',ALPHA_py);
set_param_value('GAMMA_m',GAMMA_m);
set_param_value('LAMBDA',LAMBDA);
set_param_value('DELTA_z',DELTA_z);
set_param_value('ETA0',ETA0);
set_param_value('ETA1',ETA1);
set_param_value('ETA2',ETA2);
set_param_value('THETA_s',THETA_s);
set_param_value('THETA_p',THETA_p);
set_param_value('b_p',b_p);
set_param_value('b_s',b_s);
set_param_value('RHO_q',RHO_q);
set_param_value('RHO_A',RHO_A);


set_param_value('RHO_G',RHO_G);
set_param_value('RHO_z',RHO_z);
set_param_value('A_ss',A_ss);
set_param_value('q_ss',q_ss);
set_param_value('G_ss',G_ss);


%----------------------------------------
load STEADY.mat

set_param_value('R_ss',R_ss);
set_param_value('Rk_ss',Rk_ss);

set_param_value('Ws_ss',Ws_ss);
set_param_value('Wp_ss',Wp_ss);
set_param_value('Pm_ss',Pm_ss);
set_param_value('P_ss',P_ss);
set_param_value('Pz_ss',Pz_ss);
set_param_value('C_ss',C_ss);
set_param_value('I_ss',I_ss);
set_param_value('B_ss',B_ss);
set_param_value('T_ss',T_ss);
set_param_value('er_ss',er_ss);
set_param_value('Z_ss',Z_ss);
set_param_value('ST_ss',ST_ss);
set_param_value('CE_ss',CE_ss);
set_param_value('K_ss',K_ss);
set_param_value('M_ss',M_ss);
set_param_value('Ks_ss',Ks_ss);
set_param_value('Kp_ss',Kp_ss);
set_param_value('Ls_ss',Ls_ss);
set_param_value('Lp_ss',Lp_ss);
set_param_value('EtaM_ss',EtaM_ss);
set_param_value('EtaL_ss',EtaL_ss);
set_param_value('ys_ss',ys_ss);
set_param_value('ysd_ss',ysd_ss);
set_param_value('yp_ss',yp_ss);


model;


%(1)K law 
[name = 'Capital law']
K = (1-DELTA)*K(-1) + I;

%(2)Euler Eq 
[name = 'Euler Eq']
C^(-SIGMA) = BETA*C(1)^(-SIGMA)*( (1-TAU_k)*Rk(1) + 1 -DELTA );

%(3)R and Rk 
[name = 'R and Rk']
R = (1-TAU_k)*Rk(1) + 1 -DELTA;

%(4)Energy Supply 
[name = 'Energy Supply']
((1-er)*MU)^(1+V)*(M^V)*(C^SIGMA) = (1-TAU_m)*Pm;

%(5)SOE C-D 
[name = 'SOE C-D']
ys = A*(Ks^ALPHA_sk)*(EtaL*Ls)^(1-ALPHA_sk-ALPHA_sm)*(EtaM*M)^ALPHA_sm;

%(6)SOE Labor Supply
[name = 'SOE Labor Supply']
Ws = THETA_s*Ls^b_s;

%(7)SOE FOC [K]
[name = 'SOE FOC [K]']
ALPHA_sk*ys/Ks = Rk/P;

%(8)SOE FOC [L]
[name = 'SOE FOC [L]']
(1-ALPHA_sk-ALPHA_sm)*ys/Ls = (1+b_s)*Ws/P;

%(9)SOE FOC [M]
[name = 'SOE FOC [M]']
ALPHA_sm*ys/M = (Pm+(1-er)*MU*Pz)/P;

%(10)SOE FOC [er]
[name = 'SOE FOC [er]']
LAMBDA*log(1-er) = Pz;

%(11)SOE Market Clear
[name = 'SOE Market Clear']
ys = ysd;

%(12)POE C-D 
[name = 'POE C-D']
yp = A*(Kp^ALPHA_pk)*(EtaL*Lp)^(1-ALPHA_pk-ALPHA_py)*(ysd)^ALPHA_py;

%(13)POE Labor Supply
[name = 'SOE Labor Supply']
Wp = THETA_p*Lp^b_p;

%(14)POE FOC [K]
[name = 'SOE FOC [K]']
ALPHA_pk*yp/Kp = Rk;

%(15)POE FOC [L]
[name = 'SOE FOC [L]']
(1-ALPHA_pk-ALPHA_py)*yp/Lp = (1+b_p)*Wp;

%(16)POE FOC [ysd]
[name = 'POE FOC [ysd]']
ALPHA_py*yp/ysd = P;

%(17)EtaM
[name = 'EtaM']
EtaM = q*M^(GAMMA_m-1);

%(18)Z
[name = 'Z']
Z = (1-er)*MU*M;

%(19)ST
[name = 'ST']
ST = (1-DELTA_z)*ST(-1) + Z;

%(20)EtaL
[name = 'EtaL']
EtaL = 1 - ETA0 -ETA1*ST-ETA2*ST^2;

%(21)Government Budget Constraint
[name = 'Government Budget Constraint']
G + R(-1)*B(-1) = T + Pz*Z + B;

%(22)Tax rule
[name = 'Tax rule']
T = TAU_l*(Ws*Ls+Wp*Lp)+TAU_k*Rk*K(-1)+TAU_m*Pm*M;

%(23)Capital Market Clear
[name = 'Capital Market Clear']
K = Ks + Kp;

%(24)Pz Rule
[name = 'Pz Rule']//Ls + Lp + Lold = 1;
//Pz = Pz_ss;
log(Pz) = (1-RHO_z)*log(Pz_ss)+RHO_z*log(Pz(-1))+e_z;

%(25)POE Market Clear
[name = 'POE Market Clear']
yp = C + I + G ;

%(26)q AR(1)
[name = 'q AR(1)']
log(q) = (1-RHO_q)*log(q_ss)+RHO_q*log(q(-1))+e_q;

%(27)A AR(1)
[name = 'A AR(1)']
log(A) = (1-RHO_A)*log(A_ss)+RHO_A*log(A(-1))+e_A;

%(28)G AR(1)
[name = 'G AR(1)']
log(G) = (1-RHO_G)*log(G_ss)+RHO_G*log(G(-1))+e_G;

%(29)Lold AR(1)
%[name = 'Lold AR(1)']
%log(Lold) = (1-RHO_old)*log(l0)+RHO_old*log(Lold(-1))+e_old;

%(30)Rpen AR(1)
%[name = 'Rpen AR(1)']
%log(Rpen) = (1-RHO_pen)*log(Rpen_ss)+RHO_pen*log(Rpen(-1))+e_pen;

%(31)CE
[name = 'CE']
CE = -LAMBDA*MU*M*(er+(1-er)*log(1-er));

end;

//-------------------------------------
initval;
Rk = Rk_ss;
R  = R_ss;
Ws = Ws_ss;
Wp = Wp_ss;
Pm = Pm_ss;
P  = P_ss;
Pz = Pz_ss;
C  = C_ss;
I  = I_ss;
B  = B_ss;
T  = T_ss;
er = er_ss;
Z  = Z_ss;
ST = ST_ss;
CE = CE_ss;
K  = K_ss;
M  = M_ss;
Ks = Ks_ss;
Kp = Kp_ss;
Ls = Ls_ss;
Lp = Lp_ss;
EtaM=EtaM_ss;
EtaL=EtaL_ss;
ys = ys_ss;
ysd= ysd_ss;
yp = yp_ss;
G = G_ss;
A = A_ss;
q = q_ss;


end;



//-----------------------------------------
steady;
resid(1);
check;
































